// com/porty/swing/AutoCompleteTextField.java
//     
package com.porty.swing;

import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.util.*;
import java.awt.EventQueue;

public class AutoCompleteTextField extends JTextField {
	//  
	public AutoCompleteTextField() {
		super();
		getDocument().addDocumentListener(new DocumentL());
	}
	
	//    
	private List words = new ArrayList();
	//    
	public void addWord(String word) {
		words.add(word);
	}
	// ,   
	private int beforeCompletion = 3;
	public void setBeforeCompletion(int value) {
		beforeCompletion = value;
	}
	
	// ,     
	class DocumentL implements DocumentListener {		
		//       
		public void insertUpdate(DocumentEvent e) {
			//    
			final int pos = e.getOffset() + e.getLength();
			//  
			final Document doc = e.getDocument();
			//    
			try {
				int wordStart = Utilities.getWordStart(
				   AutoCompleteTextField.this, e.getOffset());
				int wordEnd = Utilities.getWordEnd(
				   AutoCompleteTextField.this, e.getOffset());
				//   
				int wordLength = wordEnd - wordStart;
				// ,    
				if ( wordLength < beforeCompletion)
					return;
				//   
				String word = doc.getText(wordStart, wordLength);
				//       
				String wholeWord = "";
				Iterator i = words.iterator();
				while ( i.hasNext() ) {
					String next = (String)i.next();
					if ( next.startsWith(word) ) {
						//  
						wholeWord = next;
						break;
					}
				}
				// ,    
				if ( wholeWord == "") return;
				//    
				final String toComplete = 
					wholeWord.substring(wordLength);
				//     
				EventQueue.invokeLater(new Runnable() {
					public void run() {
						try {
							doc.removeDocumentListener(
								DocumentL.this);
							//   
							doc.insertString(
								pos, toComplete, null);
							//   
							setSelectionStart(pos);
							setSelectionEnd(pos +
								toComplete.length());
							//    
							doc.addDocumentListener(
								DocumentL.this);
						} catch (Exception ex) {
							ex.printStackTrace();
						}
					}
				});
			} catch (Exception ex) {
				ex.printStackTrace();
			}
		}

		//       
		public void removeUpdate(DocumentEvent p1) {			
		}
		public void changedUpdate(DocumentEvent p1) {			
		}
	}
}